<?
{
  include "constants.php";
  include "error.php";
  include "opendb.php";
  include "query.php";
  include "cookies.php";
  include "breaklines.php";
  
  //
  // Implemention of Dijkstra's algorithm based on 
  //   http://en.wikipedia.org/wiki/Dijkstra%27s_algorithm
  //

  function relax ($u, $v) {
    global $dist;
    global $previous;

    if ($dist[$v] > $dist[$u] + 1) {
      $dist[$v] = $dist[$u] + 1;
      $previous[$v] = $u;
    }
  }

  function findmin ($nodes) {
    // requires: $nodes must have at least one key
    // effects: returns the nodeid of the node with the minimum
    //          distance.
    global $dist;
    $keys = array_keys ($nodes);
    $minid = $nodes[$keys[0]];
    $mindist = $dist[$minid];

    foreach ($keys as $key) {
      $tnode = $nodes[$key];
      if ($dist[$tnode] < $mindist) {
	$mindist = $dist[$tnode];
	$minid = $tnode;
      }
    }

    return $minid;
  }
  
  function relaxNeighbors ($unode, $neighbors) {
    for ($i = 0; $i < mysql_num_rows ($neighbors); $i++) {
      $linkee = mysql_result ($neighbors, $i, 0);      
      relax ($unode, $linkee);
    }
  }

  //! microtime from http://us4.php.net/manual/en/function.microtime.php
  function getmicrotime() 
    { 
      list($usec, $sec) = explode(" ", microtime()); 
      return ((float)$usec + (float)$sec); 
    } 


  include "personname.php";
  include "preheader.php";
  openDatabase ();    
  print "<title>" . $sitename . " - Links</title>\n";
  include "header.php";

  $fromid = $_POST['fromid'];
  $toid = $_POST['toid'];
  $title = "Links from " . personName ($fromid) . " to " . personName ($toid);
  print "<h2>" . $title . "</h2>\n";

  if (($uid = checkCookie ()) != false) {
    // Find the shortest path from $fromid to $toid
    // Links may be in either direction (inviter-invitee or 
    // invitee-inviter)

    //! Added for question 5:
    $starttime = getmicrotime (true); // microseconds since January 1, 1970
    //! end timing code

    $result = executeQuery ("SELECT id FROM users");
    $longest = mysql_num_rows ($result) + 1; // longer than longest path

    // Initialize $nodes to an array of the community members.
    // Initialize the distance to all nodes as the maximum value.
    // Initialize the previous node for every node as -1 (no known path).
    for ($i = 0; $i < mysql_num_rows ($result); $i++) {
      $node = mysql_result ($result, $i, 0);
      $nodes[$i] = $node;
      $dist[$node] = $longest;
      $previous[$node] = -1;
    }

    // The distance from the fromid to itself is 0
    $dist[$fromid] = 0;

    // Q keeps track of the nodes we still need to work on
    $Q = $nodes;
    
    while (count ($Q) > 0) { // more elements in $Q
      $qsize = count($Q);
      // find the node in $Q with the minimum distance
      $unode = findmin ($Q);
      if ($unode == $toid) {
	break; // Can stop working if we've reached the toid
      }

      $u = array_search ($unode, $Q);
      $Q[$u] = false;
      $Q = array_filter ($Q); // removes false elements

      if ($qsize == count($Q)) {
	error ("Size not shrinking! " . $qsize);
      }

      // Find all nodes linked to $u
      $invitees = executeQuery ("SELECT toid FROM links WHERE fromid='$unode'");
      relaxNeighbors ($unode, $invitees);
      $inviters = executeQuery ("SELECT fromid FROM links WHERE toid='$unode'");
      relaxNeighbors ($unode, $inviters);

      //! Added for question 8
      $acquaints = executeQuery ("SELECT toid FROM acquaints WHERE fromid='$unode'");
      relaxNeighbors ($unode, $acquaints);
      //!
    }
    
    // The path is found in the $previous values from $fromid to $toid
    $numlinks = 0;
    $curnode = $toid;

    while ($curnode != $fromid && $curnode != -1) {
      $links[$numlinks++] = $curnode;
      $curnode = $previous[$curnode];
      if ($numlinks > $longest) {
	error ("Too many links!");
      }
    }

    if ($curnode != $fromid) {
      print "No path from $fromid to $toid<br>";
    } else {
      print "Number of links: " . $numlinks . "<p>";
      
      // Display links in reverse order
      $prevnode = $fromid;

      for ($i = $numlinks - 1; $i >= 0; $i--) {
	$link = $links[$i];

	// invited or was invited by?
	$invited = executeQuery ("SELECT fromid FROM links 
                                  WHERE fromid='$prevnode' AND toid='$link'");

	if (mysql_num_rows ($invited)) {
	  print "Link: " . personName ($prevnode) . " invited " 
	    . personName ($link) . "</br>";
	} else {
	  //! Changed for question 8
	  $invitee = executeQuery ("SELECT fromid FROM links 
                                  WHERE fromid='$link' AND toid='$prevnode'");

	  if (mysql_num_rows ($invitee)) {
	    print "Link: " . personName ($prevnode) 
	      . " was invited by " . personName ($link) . "</br>";
	  } else {
	    print "Link: " . personName ($prevnode) 
	      . " is acquainted with " . personName ($link) . "</br>";
	  }
	  //! end changed code
	}
	
	$prevnode = $link;
      }
    }

    //! Added for question 5:
    $endtime = getmicrotime (true); // microseconds since January 1, 1970
    $elapsed = $endtime - $starttime;
    print "<p>Processing time: " . $elapsed . " seconds<br>";
    
    //! end timing code


    print "<p><a href=\"find-links.php\">Find More Links</a>";
    mysql_close ();
  } else {
    error ("Only community members may view this page.<br><p>
            Please <a href=\"" . $baseurl . "/login.html\">login</a>.");
  }

  include "footer.php";
}
?>    
